package cn.com.qmth.examcloud.service.core.api;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.commons.base.exception.StatusException;
import cn.com.qmth.examcloud.commons.web.security.bean.User;
import cn.com.qmth.examcloud.commons.web.support.ControllerSupport;
import cn.com.qmth.examcloud.core.basic.service.AuthService;
import cn.com.qmth.examcloud.core.basic.service.bean.LoginInfo;
import io.swagger.annotations.ApiOperation;

/**
 * 鉴权
 *
 * @author WANGWEI
 * @date 2018年5月25日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@RestController
@RequestMapping("${app.api.root}/" + "auth")
public class AuthController extends ControllerSupport {

	@Autowired
	AuthService authService;

	@ApiOperation(value = "登入", notes = "")
	@PostMapping("login")
	public User login(@RequestBody LoginInfo loginInfo) {
		User user = authService.login(loginInfo);
		return user;
	}

	@ApiOperation(value = "登出", notes = "")
	@PostMapping("logout")
	public void logout() {
		User user = getAccessUser();
		if (null == user) {
			throw new StatusException("P-001001", "用户已登出");
		}
		authService.logout(user);
	}

	@ApiOperation(value = "获取登录用户", notes = "")
	@PostMapping("getLoginUser")
	public User getLoginUser(@RequestParam String key, @RequestParam String token) {

		if (StringUtils.isBlank(key)) {
			throw new StatusException("P-001009", "key is blank");
		}
		if (StringUtils.isBlank(key)) {
			throw new StatusException("P-001010", "token is blank");
		}

		return authService.getLoginUser(key, token);
	}

}