package cn.com.qmth.examcloud.core.basic.dao.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;

import cn.com.qmth.examcloud.commons.web.helpers.tree.TreeNode;
import cn.com.qmth.examcloud.commons.web.support.JpaEntitySupport;

/**
 * 权限
 *
 * @author WANGWEI
 * @date 2018年5月23日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@Entity
@Table(name = "EC_B_PRIVILEGE")
public class Privilege extends JpaEntitySupport implements TreeNode {

	private static final long serialVersionUID = -6288949236298877031L;

	/**
	 * 权限ID
	 */
	@Id
	@GeneratedValue
	private Long id;

	/**
	 * 权限码
	 */
	@Column(unique = true, nullable = false)
	private String privilegeCode;

	/**
	 * 权限名称
	 */
	@Column(unique = true, nullable = false)
	private String name;

	/**
	 * 父权限ID
	 */
	private Long parentId;

	/**
	 * 组(权限分组,同一组的权限构成权限树)
	 */
	@Column(unique = false, nullable = false)
	private Long groupId;

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getPrivilegeCode() {
		return privilegeCode;
	}

	public void setPrivilegeCode(String privilegeCode) {
		this.privilegeCode = privilegeCode;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Long getParentId() {
		return parentId;
	}

	public void setParentId(Long parentId) {
		this.parentId = parentId;
	}

	public Long getGroupId() {
		return groupId;
	}

	public void setGroupId(Long groupId) {
		this.groupId = groupId;
	}

	@Override
	public String getTreeId() {
		return null;
	}

	@Override
	public void setTreeId(String treeId) {

	}

	@Override
	public String getTreeName() {
		return null;
	}

	@Override
	public void setTreeName(String treeName) {

	}

	@Override
	public String getParentTreeId() {
		return null;
	}

	@Override
	public void setParentTreeId(String parentTreeId) {

	}

}
